#!/usr/bin/python3
from map import *
from player import *
from gameparser import *
from datetime import datetime
from items import *
from level_1 import *
start_time = ""
global current_room
global current_level


def list_of_items(items):
    new_list = ""
    for number in range(len(items)):
        if number == len(items) - 1:
            new_list += items[number]["name"]
        else:
            new_list += items[number]["name"] + ", "

    return new_list


def print_room_items(room):
    if room["items"]:
        print("There is", list_of_items(room["items"]), "here." + "\n")


def print_inventory_items(items):
    if items:
        print("You have", list_of_items(items) + "." + "\n")


def print_room(room):
    # Display room name
    print()
    print(room["name"].upper())
    print()
    # Display room description
    print(room["description"])
    print()
    print_room_items(room)

    #
    # COMPLETE ME!
    #


def exit_leads_to(exits, direction):
    return level1[exits[direction]]["name"]


def print_exit(direction, leads_to):
    print("GO " + direction.upper() + " to " + leads_to + ".")


def print_menu(exits, room_items, inv_items):
    print("You can:")
    # Iterate over available exits
    for direction in exits:
        # Print the exit name and where it leads to
        print_exit(direction, exit_leads_to(exits, direction))
    for items in room_items:
        if items["pick-up"]:
            print("TAKE", items["id"], "to take", items["name"] + ".")

    for items in inv_items:
        print("DROP", items["id"], "to drop", items["name"] + ".")
    for items in inv_items:
        if "open" in items:
            if not items["open"]:
                print("OPEN", items["id"], "to open", items["name"] + ".")
    print("CHECK TIMER to check the time remaining")
    if current_room == location_door:
        print("UNLOCK DOOR to attempt to unlock the escape door")
    if item_note in inv_items:
        print("READ NOTE to read the hidden note")
    if item_safe in room_items:
        if not item_safe["open"]:
            print("OPEN SAFE to attempt to open the safe")
        else:
            "You've already opened the safe"
    if item_batteries in inventory:
        print("USE BATTERIES to use the batteries")
    if (powered_torch in inv_items) or (unpowered_torch in inv_items):
        print("USE TORCH to use your torch")

    print("What do you want to do?")


def is_valid_exit(exits, chosen_exit):
    return chosen_exit in exits


def execute_go(direction):
    global current_room
    if is_valid_exit(current_room["exits"], direction):
        new_room = move(current_room["exits"], direction)
        current_room = new_room
        return current_room
    else:
        print("you cannot go there")


def execute_take(item_id):
    found = False
    for items in current_room["items"]:
        if item_id == items["id"]:
            inventory.append(items)
            current_room["items"].remove(items)
            found = True

    if not found:
        print("You cannot take that.")


def execute_drop(item_id):
    found = False
    for items in inventory:
        if items["id"] == item_id:
            current_room["items"].append(items)
            inventory.remove(items)
            found = True

    if not found:
        print("You cannot drop that.")


def unlock_door():
    global current_level
    global current_room
    global start_time
    if current_room["name"] == "Escape door":
        if item_key in inventory:
            current_time = datetime.now()
            time_taken = (current_time - start_time).total_seconds()
            minutes = time_taken // 60
            seconds = time_taken % 60
            while True:
                print("WELL DONE! You've escaped LEVEL 1 in a time of", round(minutes), "minutes and", round(seconds), "seconds")
                print("type CONTINUE to begin the next level")
                response = input()
                print(normalise_input(response)[0])
                if normalise_input(response)[0] == "continue":
                    current_level = levels["level 2"]
                    current_room = current_level["entrance"]
                    start_time = datetime.now()
                    print("(introduction to level 2)")
                    break

        else:
            print("You need a key to open the door")
    else:
        print("There is no door to open")


def check_timer():
    current_time = datetime.now()
    time_taken = current_time - start_time
    time_left = 1200 - time_taken.total_seconds()
    minutes = time_left//60
    seconds = time_left%60
    print("You have", round(minutes), "minutes and", round(seconds), "seconds")


def execute_command(command):
    if 0 == len(command):
        return

    if command[0] == "go":
        if len(command) > 1:
            execute_go(command[1])
        else:
            print("Go where?")

    elif command[0] == "take":
        if len(command) > 1:
            execute_take(command[1])
        else:
            print("Take what?")

    elif command[0] == "drop":
        if len(command) > 1:
            execute_drop(command[1])
        else:
            print("Drop what?")

    elif command[0] == "read":
        if command[1] == "note":
            read_note()
        else:
            print("read what?")

    elif command[0] == "open":
        if command[1] == "diary":
            open_diary()
        elif command[1] == "safe":
            open_safe()
        else:
            print("open what?")

    elif command[0] == "check":
        if command[1] == "timer":
            check_timer()
        else:
            print("Check what?")
    elif command[0] == "unlock":
        if command[1] == "door":
            unlock_door()
        else:
            print("unlock what?")
    elif command[0] == "use":
        if command[1] == "batteries":
            use_battery()
        if command[1] == "torch":
            use_torch(current_room)
        else:
            print("use what?")
    else:
        print("This makes no sense.")


def menu(exits, room_items, inv_items):
    # Display menu

    print_menu(exits, room_items, inv_items)

    # Read player's input
    user_input = input("> ")

    # Normalise the input
    normalised_user_input = normalise_input(user_input)

    return normalised_user_input


def move(exits, direction):
    # Next room to go to
    return level1[exits[direction]]


# This is the entry point of our program
def main():
    global start_time
    start_time = datetime.now()
    # Main game loop
    while True:
        current_time = datetime.now()
        time_taken = current_time - start_time
        time_left = 1200 - time_taken.total_seconds()
        if time_left < 0:
            print("Oh no! You ran out of time!")
            break
        # Display game status (room description, inventory etc.)
        print_room(current_room)
        print_inventory_items(inventory)

        # Show the menu with possible actions and ask the player
        command = menu(current_room["exits"], current_room["items"], inventory)

        # Execute the player's command
        execute_command(command)


# Are we being run as a script? If so, run main().
# '__main__' is the name of the scope in which top-level code executes.
# See https://docs.python.org/3.4/library/__main__.html for explanation
if __name__ == "__main__":
    main()
